////=====================================================================================
//// ú, ļ
////=====================================================================================
#define  IP_INIT_GLOBAL
#include "Nano1X2Series.h"
#include "IP_Init.h"

//// ʱú ///////////////////////////////////////////////////////////////////////
void SysClkInit(void)
{
  SYS_UnlockReg() ;                                        // ֻ HIRC=12M  32768
  CLK->PWRCTL  = CLK_PWRCTL_DELY_EN | CLK_PWRCTL_HIRC_EN | CLK_PWRCTL_LXT_EN ;         
 	while((CLK->CLKSTATUS & CLK_CLKSTATUS_LXT_STB) == 0) ;   //  32768 ȶ            
  CLK->CLKDIV0 = CLK_HCLK_CLK_DIVIDER(6) ;                 // HCLK 6ƵΪ 2MHz  
  CLK->CLKDIV1 = CLK_TMR1_CLK_DIVIDER(12) ;                // Timer1 12Ƶ 1M   
  
  CLK->CLKSEL1 = CLK_CLKSEL1_TMR1_S_HCLK                   // ʱѡ
               | CLK_CLKSEL1_TMR0_S_LXT  
               | CLK_CLKSEL1_UART_S_LXT ; 
  CLK->CLKSEL2 = CLK_CLKSEL2_SPI1_S_HCLK ;  
                                                           // ʱʹ
  CLK->AHBCLK  = CLK_AHBCLK_SRAM_EN 
               | CLK_AHBCLK_ISP_EN 
               | CLK_AHBCLK_GPIO_EN ;
  CLK->APBCLK  = CLK_APBCLK_LCD_EN  
               | CLK_APBCLK_TMR1_EN 
               | CLK_APBCLK_UART1_EN
               | CLK_APBCLK_UART0_EN  
               | CLK_APBCLK_SPI1_EN 
               | CLK_APBCLK_TMR0_EN 
               | CLK_APBCLK_RTC_EN ; 
  SYS_LockReg() ;                                              
}                        
void Delayus(uint32_t Tim)                                
{
  uint32_t Tick = TIMER1->DR ;
  while(((TIMER1->DR - Tick)&0xFFFFFF) <= Tim) ;
}
//// Timer1, 1MHz ,  // 24λ,  16.77, ͨöʱ ////////////////////////
void Timer1Init(void) 
{
  TIMER1->CTL    = TIMER_CONTINUOUS_MODE | TIMER_CTL_TMR_EN_Msk ; 
  TIMER1->PRECNT = 0 ;                                                      
  TIMER1->IER    = 0 ;                                     // ж
}
void UART0_Init(void)
{
  UART0->FUN_SEL = UART_FUNC_SEL_UART ;                                        
  UART0->TLCTL   = 0x3303 ;                      // 8bit 1-stop no parity RTS:14,RxFiFo:14   
  UART0->BAUD    = 0x02 ;                        // 9600: 0x02, 0x55
  UART0->BR_COMP = 0x55 ;                        // 4800: 0x06, 0x80000082
  UART0->TMCTL   = 0x00000060 ;                  //Max reception interval 96bit
  UART0->IER     = UART_IER_RTO_IE_Msk | UART_IER_RDA_IE_Msk ; 
  UART0->CTL     = 0x07000000 + UART_CTL_WAKE_THRESH_EN_Msk ; 
  NVIC_SetPriority(UART0_IRQn, 2) ;  
  NVIC->ISER[0]  = 1 << UART0_IRQn ;
  Delayus(70) ;
}
void UART1_Init(void)
{
  UART1->FUN_SEL = UART_FUNC_SEL_UART ;                                      
  UART1->TLCTL   = 0x3303 ;                      //8bit 1-stop no parity RTS:14,RxFiFo:14   
  UART1->BAUD    = 0x0C ;                        // 2400: 0x0C, 0x6D
  UART1->BR_COMP = 0x6D ;                        
  UART1->TMCTL   = 0x00000060 ;                  //Max reception interval 96bit
  UART1->IER     = UART_IER_RTO_IE_Msk | UART_IER_RDA_IE_Msk ; 
  UART1->CTL     = 0x07000000 + UART_CTL_WAKE_THRESH_EN_Msk ; 
  NVIC_SetPriority(UART1_IRQn, 2) ;  
  NVIC->ISER[0]  = 1 << UART1_IRQn ;
  Delayus(70) ;
}
//// Timer0, 32768Hz ڼ ///////////////////////////////////////////////////////////
void Timer0Init(void)
{
  TIMER0->CTL    = TIMER_PERIODIC_MODE | TIMER_CTL_WAKE_EN_Msk | TIMER_CTL_SW_RST_Msk ;   
  TIMER0->PRECNT = 0 ;                                     // Ƶ
  TIMER0->CMPR   = 32768*1 ;                               // ֵ
  TIMER0->ISR    = ~0 ;                                    // ־
  TIMER0->IER    = TIMER_IER_TMR_IE_Msk ;                  // ж
  NVIC_SetPriority(TMR0_IRQn, 2) ;   
  NVIC_EnableIRQ(TMR0_IRQn) ;                              
  Delayus(70) ;                                            //һʱӺ, дЧ
  TIMER0->CTL |= TIMER_CTL_TMR_EN_Msk ;                    //Ȼ/Ķָ
}
void RTC_Init(void)
{
  RTC->INIR = 0xA5EB1357 ;                                 // ˳λ, 
  RTC->AER  = 0xA965 ;                                     // дFCR,TAR,CARͱRAM
  while((RTC->AER & RTC_AER_ENF_Msk)==0);
  RTC->TLR  = 0x120000 ;                                   // 12:00:00
  RTC->CLR  = 0x150501 ;                                   // 2015/05/01
  RTC->TSSR = 1 ;                                          // 24Сʱ
  RTC->DWR  = 5 ;                                          // 
  RTC->RIER = 2 ;                                          // ʹ Tick ж
  RTC->TTR  = 0x08 ;                                       // Tick һӻһ  
  NVIC_SetPriority(RTC_IRQn, 2);
  NVIC->ISER[0] = 1ul<<RTC_IRQn ;		
  Delayus(70) ;
}
/////////////////////////////////////////////////////////////////////////////////////////
// SPI1_MOSI0,PIN56_PA12  
// SPI1_MISO0,PIN57_PA13   
// SPI1_CLK,  PIN58_PA14
// SPI1_SS0,  PIN59_PA15               // , ֹ1,滹
void SPI1_Init(uint32_t Div)
{
  SPI1->CLKDIV = Div - 1 ;                                 // coefficient of devide frequency
  SPI1->CTL    = SPI_CTL_FIFOM_Msk                         // Enable FiFo
               | SPI_CTL_RX_NEG_Msk ;                      // Receiving at falling edge
  SPI_SET_SUSPEND_CYCLE(SPI1, 1) ;                         // suspend 1 SPI_CLK every transfer
  SPI_SET_DATA_WIDTH(SPI1, 8) ;                            // 8 bit every transfer
}
void LCD_Init(void)                              // 8ִMEM0,MEM1,MEM2,MEM3 
{               
  LCD->CTL     = LCD_FREQ_DIV96                           // LCDʱ341*4Ƶ=85Hz
               | LCD_MUX_ONE_FOURTH                        // 4-MUX
               | LCD_CTL_PDDISP_EN_Msk                     // ״̬, LCD ʾ
               | LCD_CTL_EN_Msk  ;                         // LCD ʹ

	LCD->DISPCTL = LCD_DISPCTL_Res_Sel_Msk                   // ڲ400K                    
               | LCD_DISPCTL_BV_SEL_Msk                    // R-Type
               | LCD_DISPCTL_IBRL_EN_Msk                   // ʹ
               | LCD_BIAS_THIRD ;                          // 1/3ƫѹ
}

// 궨, ֹͬͻ
#define  a            0x0800  
#define  b            0x0400  
#define  c            0x0200  
#define  d            0x0100  
#define  e            0x0002  
#define  f            0x0008  
#define  g            0x0004  
uint16_t TabLCD[] ={
    a+b+c+d+e+f ,                  // 0
    b+c ,                          // 1
    a+b+d+e+g ,                    // 2
    a+b+c+d+g ,                    // 3
    b+c+f+g ,                      // 4
    a+c+d+f+g ,                    // 5
    a+c+d+e+f+g ,                  // 6
    a+b+c ,                        // 7
    a+b+c+d+e+f+g ,                // 8
    a+b+c+d+f+g ,                  // 9
  
    d+e+f ,                        // L
    c+d+e+g,                       // o
    g ,                            // -
    e+g ,                          // r
    a+d+e+f+g ,                    // E
    0 ,                            
};
